.nolist
include \masm32\include\masm32rt.inc
useMovup=1	; lddqu faster than movdqu on P4 if data are in cache; movups does the same but is one byte shorter
usexps=0	; movhps xmm0, [esi+8]/movlps xmm0, [esi]: a lot slower on P4, 5000+ cycles instead of 3500 for the 5000 byte string

.686
.xmm
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 10000

StrCmpSSE_ci	PROTO: DWORD, :DWORD
StrCmpSSE	PROTO: DWORD, :DWORD

; Usage variants (they all produce the same code):
;	ldq xmm0, oword ptr [esi]	; full version, like lddqu xmm0, oword ptr [esi]
;	ldq xmm0, [esi]	; short version, like movupd xmm1, [edi]
;	ldq xmm0, esi	; lazy version
ldq MACRO xreg, reg	; substitute for SSE3 lddqu xmm0, [esi] with ml useMovup
LOCAL isx, isr, isb
  isb INSTR <reg>, <[>
  if isb
	isr INSTR <eax/ecx/edx/ebx/eSp/ebp/esi/edi>, @SubStr(<reg>, isb+1, 3)
  else
	isr INSTR <eax/ecx/edx/ebx/eSp/ebp/esi/edi>, <reg>
  endif
  if isr
	isx INSTR <xmm0xmm1xmm2xmm3xmm4xmm5xmm6xmm7>, <xreg>
	if isx
		isx=(isx-1)*2
		db 0F2h, 0Fh, 0F0h
		db isx+(isr-1)/4
	else
		echo <xreg> is not a valid xmm register
		.err
	endif
  else
	echo <reg> is not a valid register
	.err
  endif
ENDM

.data
align 16
Dummy1	db 1	; activate to misalign - use mov eax, 123456789 for case-insensitive comparison
Src1	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
   REPEAT 48
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
   ENDM
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos!", 0, "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
align 16
Dummy2	db 1,1	; activate to misalign
Src2	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
   REPEAT 48
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
   ENDM
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?", 0, "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
align 16
Srcs1	db "A string ?", 0, "abcdefghij"
align 16
Srcs2	db "A string !", 0, "ABCDEFGHIJ"
LenSrcs1	dd 10
LenSrcs2	dd 10

.data?
Dest	db 100 dup(?)
LenSrc1	dd ?
LenSrc2	dd ?

.code
start:
	if 0	; activate for testing correctness
		mov ebx, esp
		push offset Src1
		push offset Src2
		call RockoonJ3	; StrCmpSSE_ci
		push edx
		print str$(eax), " diff at pos "
		pop edx
		print str$(edx), " (zero-based)", 13, 10
		sub ebx, esp
		print "Stack: "
		print str$(ebx)
		getkey
		exit
	endif
	push 1
	call ShowCpu	; prints the brand string and returns SSE level@
	print "String comparison: short string 10 bytes, long string "
	mov LenSrc1, len(offset Src1)
	mov LenSrc2, len(offset Src2)
	add LenSrc1, 50
	add LenSrc2, 50
	print str$(LenSrc1), 13, 10
	REPEAT 2
	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src1
		push offset Src2
		call StrCmpSSE
	counter_end
	print str$(eax), 9, "cycles for SSE with null check, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src1
		push offset Src2
		call StrCmpSSE_ci
	counter_end
	print str$(eax), 9, "cycles for SSE with null check, long string, case-insensitive", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src1
		push offset Src2
		call Lingo32
	counter_end
	print str$(eax), 9, "cycles for Lingo, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src1
		push offset Src2
		call Frank
	counter_end
	print str$(eax), 9, "cycles for Frank, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src1
		push offset Src2
		call Rockoon
	counter_end
	print str$(eax), 9, "cycles for Rockoon, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src1
		push offset Src2
		call RockoonJ
	counter_end
	print str$(eax), 9, "cycles for RockoonJ, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src1
		push offset Src2
		call RockoonJ2
	counter_end
	print str$(eax), 9, "cycles for RockoonJ2, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src1
		push offset Src2
		call RockoonJ3
	counter_end
	print str$(eax), 9, "cycles for RockoonJ3, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src1
		lea edi, Src2
		invoke crt_strcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for crt_strcmp, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src1
		lea edi, Src2
		invoke crt__stricmp, esi, edi		; case-insensitive, factor 3 slower
	counter_end
	print str$(eax), 9, "cycles for crt__stricmp, long string, case-insensitive", 13, 10

if 0
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
	lea esi, Src1
	lea edi, Src2
	movzx eax, BYTE ptr [esi]
	movzx ebx, BYTE ptr [edi]
	.While eax == ebx
@@:		or eax, ebx
		jz @F
		inc esi
		inc edi
		movzx eax, BYTE ptr [esi]
		movzx ebx, BYTE ptr [edi]
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for qWord, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
	mov esi, offset Src1
	mov edi, offset Src2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
	mov esi, offset Src1
	mov edi, offset Src2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		.Break .if !eax
		.Break .if !edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx check null, long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src1
		lea edi, Src2
		mov ecx, LenSrc1
		repe cmpsb
	counter_end
	print str$(eax), 9, "cycles for repe cmpsb, long string", 13, 10
endif
	counter_begin LOOP_COUNT/10, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src1
		lea edi, Src2
		invoke lstrcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for lstrcmp, long string", 13, 10, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		push offset Srcs1
		push offset Srcs2
		call StrCmpSSE
	counter_end
	print str$(eax), 9, "cycles for SSE with null check, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		push offset Srcs1
		push offset Srcs2
		call StrCmpSSE_ci
	counter_end
	print str$(eax), 9, "cycles for SSE with null check, 10 bytes, case-insensitive", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		push offset Srcs1
		push offset Srcs2
		call Lingo32
	counter_end
	print str$(eax), 9, "cycles for Lingo, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		push offset Srcs1
		push offset Srcs2
		call Frank
	counter_end
	print str$(eax), 9, "cycles for Frank, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		push offset Srcs1
		push offset Srcs2
		call Rockoon
	counter_end
	print str$(eax), 9, "cycles for Rockoon, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		push offset Srcs1
		push offset Srcs2
		call RockoonJ
	counter_end
	print str$(eax), 9, "cycles for RockoonJ, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		push offset Srcs1
		push offset Srcs2
		call RockoonJ2
	counter_end
	print str$(eax), 9, "cycles for RockoonJ2, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		push offset Srcs1
		push offset Srcs2
		call RockoonJ3
	counter_end
	print str$(eax), 9, "cycles for RockoonJ3, 10 bytes", 13, 10

if 0
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		lea esi, Srcs1
		lea edi, Srcs2
		invoke crt_strcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for crt_strcmp, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		lea esi, Srcs1
		lea edi, Srcs2
		invoke crt__stricmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for crt__stricmp, 10 bytes, case-insensitive", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
	lea esi, Srcs1
	lea edi, Srcs2
	movzx eax, BYTE ptr [esi]
	movzx ebx, BYTE ptr [edi]
	.While eax == ebx
@@:		or eax,ebx
		jz @F
		inc esi
		inc edi
		movzx eax, BYTE ptr [esi]
		movzx ebx, BYTE ptr [edi]
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for qWord, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
	mov esi, offset Srcs1
	mov edi, offset Srcs2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
	mov esi, offset Srcs1
	mov edi, offset Srcs2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		.Break .if !eax
		.Break .if !edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx check null, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		lea esi, Srcs1
		lea edi, Srcs2
		mov ecx, LenSrcs1
		repe cmpsb
	counter_end
	print str$(eax), 9, "cycles for repe cmpsb, 10 bytes", 13, 10
endif
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		lea esi, Srcs1
		lea edi, Srcs2
		invoke lstrcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for lstrcmp, 10 bytes", 13, 10, 10
	ENDM
	print "Codesizes:", 13, 10
	print "Lingo:", 9
	mov eax, Lingo32_E
	sub eax, Lingo32_S
	print str$(eax), 13, 10
	print "Frank:", 9
	mov eax, Frank_endp
	sub eax, Frank
	print str$(eax), 13, 10
	print "Rockoon:", 9
	mov eax, Rockoon_endp
	sub eax, Rockoon
	print str$(eax), 13, 10
	print "RockoonJ:", 9
	mov eax, RockoonJ_endp
	sub eax, RockoonJ
	print str$(eax), 13, 10
	print "RockoonJ2:", 9
	mov eax, RockoonJ2_endp
	sub eax, RockoonJ2
	print str$(eax), 13, 10
	print "RockoonJ3:", 9
	mov eax, RockoonJ3_endp
	sub eax, RockoonJ3
	print str$(eax), 13, 10
	print "SSE:", 9
	mov eax, StrCmpSSE_E
	sub eax, StrCmpSSE_S
	print str$(eax), 9, "(MasmBasic)", 13, 10
	inkey "--- ok ---"
	exit

push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
Rockoon proc
	mov eax, [esp+4]
	mov ecx, [esp+8]
;	mov ebx, 325
	sub ecx, eax
align 4	; better than align 16 for 10-byte string
@@:
	mov edx, [eax]
	cmp edx, [eax + ecx]
	jne @f
	mov edx, [eax + 4]
	cmp edx, [eax + ecx + 4]
	jne @f
	add eax, 8
	jmp @B
@@:	sub eax, [esp+4]	; return the relative position in ecx
	ret 8
Rockoon endp
Rockoon_endp:

align 16
RockoonJ proc
	mov eax, [esp+4]
	mov ecx, [esp+8]
;	mov ebx, 325
	sub ecx, eax
align 16
@@:
        mov edx, [eax]
        cmp edx, [eax + ecx]
        jne @f 
        add eax, 8
        mov edx, [eax + ecx - 4]
        cmp edx, [eax - 4]
        je @B
;        dec ebx
;        jnz @b  
@@:
	sub eax, [esp+4]	; return the relative position in ecx
	ret 8
RockoonJ endp
RockoonJ_endp:

align 16
RockoonJ2 proc
	pop edx
	pop eax
	pop ecx
	push edx
	sub ecx, eax
align 8
@@:	mov edx, [eax+ecx]
	cmp edx, [eax]
	jne @F
	if 0
	mov edx, [eax+ecx+4]		; for qWord
	cmp edx, [eax+4]
	lea eax, [eax+8]
	else
	add eax, 4
	mov edx, [eax+ecx]
	cmp edx, [eax]
	lea eax, [eax+4]
	endif
	je @B
@@:	sub eax, [esp-4]		; return the relative position in eax
	ret
RockoonJ2 endp
RockoonJ2_endp:

align 16
RockoonJ3 proc
	pop edx
	pop eax
	pop ecx
	sub ecx, eax
	push edx
align 8			; aka mov edi, edi
@@:
	REPEAT 1	; further unrolling slows it down
	mov edx, [eax+ecx]
	cmp edx, [eax]
	lea eax, [eax+4]
	jne @F
	ENDM
	mov edx, [eax+ecx]
	cmp edx, [eax]
	lea eax, [eax+4]
	je @B
@@:	sub eax, [esp-4]	; return the relative position in eax
	ret
RockoonJ3 endp
RockoonJ3_endp:

StrCmpSSE_S:
StrCmpSSE_ci proc s1, s2
	mov eax, 123456789	; magic xor'ed with esp looks safe enough
		xor eax, esp
StrCmpSSE_ci endp
StrCmpSSE proc s1, s2
		xor eax, esp
	push esi
	push edi
	mov esi, [esp+12]	; string 1
	mov edi, [esp+16]	; string 2
	pxor xmm2, xmm2	; xmm2 = 0 for checking nullbyte
	cmp eax, 123456789	; magic for case-insensitive?
	je @F
;	test dl, 15	; 3 bytes instead of 6
	test edi, 15	; string 2 16-byte aligned?
	je E1
	xchg esi, edi	; no, so swap strings and try the other one
	test edi, 15	; string 1 16-byte aligned?
	je E1
@@:	mov edx, edi	; save a copy to ...
	if useMovup
	movups xmm1, [edi]	; use first 16 bytes of
	movups xmm0, [esi]	; both strings, unaligned
	else
	lddqu xmm1, oword ptr [edi]	; use first 16 bytes of
	lddqu xmm0, oword ptr [esi]	; both strings, unaligned
	endif
	and edi, -16	; align initial pointer to 16-byte boundary
	sub edx, edi	; ... get the difference
	push esi	; keep a copy, since below we don't know if we swapped strings
	sub esi, edx	; align esi with new edi
	cmp eax, 123456789	; magic for case-insensitive?
	je ciE1
	pcmpeqb xmm0, xmm1	; compare packed bytes in xmm0 and xmm1 for equality
	test esi, 15
	je aE2	; if esi is 16-byte aligned, we are lucky: go to "aligned" second entry point
	jmp uE2
ciE1:	mov eax, 20202020h	; for or 32, case-insensitive
	movd xmm3, eax
	pshufd xmm3, xmm3, 0	; linefeeds for comparison in xmm2
	jmp ciE2
ciL1:
	if useMovup
	movups xmm0, oword ptr [esi]	; unaligned version of movapd (->[url=\masm32\Gfa2Masm\MemCopySSE2.asc]MemCopySSE2[/url])
	else
	lddqu xmm0, oword ptr [esi]	; unaligned version of movapd (->[url=\masm32\Gfa2Masm\MemCopySSE2.asc]MemCopySSE2[/url])
	endif
	movapd xmm1, [edi]
ciE2:	pcmpeqb xmm2, xmm1	; check nullbytes
	por xmm0, xmm3
	por xmm1, xmm3
	pcmpeqb xmm0, xmm1	; compare packed bytes in [m128] and xmm0 for equality
	lea edi, [edi+16]	; increase position
	lea esi, [esi+16]	; in memory
	pmovmskb eax, xmm2	; set byte mask in eax
	pmovmskb edx, xmm0	; set byte mask in eax
	test eax, eax
	jne xEnd
	cmp edx, 65535
	je ciL1
	jmp xEnd

E1:	push esi
	test esi, 15	; string 1 16-byte aligned? If yes, go to "fully aligned" loop
	je aL1	; case-insensitive solution might be to POR two xmm regs
uL1:
	if useMovup
	movups xmm0, oword ptr [esi]	; unaligned version of movapd (->[url=\masm32\Gfa2Masm\MemCopySSE2.asc]MemCopySSE2[/url])
	elseif usexps
	movhps xmm0, qword ptr [esi+8]	; a lot slower on P4, 5500+ cycles
	movlps xmm0, qword ptr [esi]	; instead of 3500 for the 5000 byte string
	else
	lddqu xmm0, oword ptr [esi]	; unaligned version of movapd (->[url=\masm32\Gfa2Masm\MemCopySSE2.asc]MemCopySSE2[/url])
	endif
	pcmpeqb xmm0, [edi]	; compare packed bytes in [m128] and xmm0 for equality
uE2:	pcmpeqb xmm2, [edi]	; compare packed bytes in [m128] and xmm2 for equality
	lea edi, [edi+16]	; increase position
	lea esi, [esi+16]	; in memory
	pmovmskb eax, xmm2	; set byte mask in eax
	pmovmskb edx, xmm0	; set byte mask in eax
	test eax, eax
	jne xEnd
	cmp edx, 65535
	je uL1
	jmp xEnd
aL1:	movapd xmm0, [esi]	; 20% faster
	pcmpeqb xmm0, [edi]	; compare packed bytes in [m128] and xmm0 for equality
aE2:	pcmpeqb xmm2, [edi]	; compare packed bytes in [m128] and xmm2 for equality
	lea edi, [edi+16]	; increase position
	lea esi, [esi+16]	; in memory
	pmovmskb eax, xmm2	; set byte mask in eax
	pmovmskb edx, xmm0	; set byte mask in eax
	test eax, eax
	jne xEnd
	cmp edx, 65535
	je aL1
xEnd:	not edx	; reverse bits for bsf
	or edx, eax	; add zero byte info
	bsf edx, edx	; find bit position
	mov eax, esi	; get current position
	pop esi	; retrieve initial position (strings may have been swapped)
	sub eax, esi	; get relative position
	lea edx, [eax+edx-16]	; 16 if null-based
	mov esi, [esp+12]	; get original string
	mov edi, [esp+16]	; pointers for comparison
	movzx eax, byte ptr [esi+edx]	; edx returns 0-based position of first mismatch
	movzx esi, byte ptr [edi+edx]	; eax returns difference of mismatching bytes
	sub eax, esi
	pop edi
	pop esi
	ret 8
StrCmpSSE endp
StrCmpSSE_E:
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
;...........................................................................................
comment * New lstrcmp by Lingo *
Align	16
Lingo32_S:
db			8Dh, 49h, 0, 90h
Lingo32 proc lpString1:DWORD, lpString12:DWORD
	mov edx, [esp+4]		; edx-> lpString1
	xor eax, eax		; eax->index
	mov [esp+4], esi		; save esi register
	mov esi, edx		; esi-> lpString1
	mov edx, [edx]		; edx-> lpString1
	mov ecx, [esp+8]		; ecx-> lpString2
	mov [esp+8], edi		; save edi register
	lea edi, [edx+0FEFEFEFFh]
	cmp edx, [ecx]		; ecx-> lpString2
	jne @K1
	test edi, 80808080h
	jne @@2
	mov edx, [esi+4]
	add eax, 4
	cmp edx, [ecx+4]		; ecx-> lpString2
	mov edi, 80808080h		; edi->mask-> 80808080h
	jne @K1
@@:
	add edx, 0FEFEFEFFh
	test edx, edi		; edi->mask-> 80808080h
	jne @@1		;found zero or >80h
	mov edx, [esi+eax+4]		; esi-> lpString1
	add eax, 4
	cmp edx, [ecx+eax]		; ecx-> lpString2
	je @b
@K1:
	movzx edi, byte ptr [ecx+eax]		; ecx-> lpString2
	and edx, 0FFh		; edi-> lpString1
	sub edx, edi
	jne @K2
	add edi, edi
	je @K2
	movzx edi, byte ptr [ecx+eax+1]		; ecx-> lpString2
	movzx edx, byte ptr [esi+eax+1]		; esi-> lpString1
	sub edx, edi
	jne @K2
	add edi, edi
	je @K2
	movzx edi, byte ptr [ecx+eax+2]		; ecx-> lpString2
	movzx edx, byte ptr [esi+eax+2]		; esi-> lpString1
	sub edx, edi
	jne @K2
	add edi, edi
	je @K2
	movzx edx, byte ptr [ecx+eax+3]		; ecx-> lpString2
	movzx eax, byte ptr [esi+eax+3]		; esi-> lpString1
	mov esi, [esp+4]		; restore esi register
	sub eax, edx		; 2 strings are equal or not
	mov edi, [esp+8]		; restore edi register
	ret 8
@K2:
	mov esi, [esp+4]		; restore esi register
	mov eax, edx		; 2 strings are equal or not
	mov edi, [esp+8]		; restore edi register
	ret 8
; ..............................................................................................
db 8Dh, 0A4h, 24h, 0, 0, 0, 0, 90h		; nop's
@@1:		; there is a zero or >80h in the first string
	add edx, 1010101h		; restore edx
@@2:
	cmp dl, [ecx+eax]		; ecx-> lpString2
	jne @M1
	test dl, dl
	je @@3
	cmp dh,[ecx+eax+1]		; ecx-> lpString2
	jne @M2
	test dh, dh
	je @@3
	shr edx, 16
	cmp dl, [ecx+eax+2]		; ecx-> lpString2
	jne @M3
	test dl, dl
	je @@3
	cmp dh, [ecx+eax+3]		; ecx-> lpString2
	jne @M4
	test dh, dh
	je @@3
	mov edx, [esi+eax+4]		; esi-> lpString1
@@:
	and edx, 07F7F7F7FH
	add eax, 4
	add edx, 0FEFEFEFFh
	test edx, edi		; edi->mask-> 80808080h
	mov edx, [esi+eax]		; esi-> lpString1
	jne @@2		; there is a zero or 80h in the first string
	cmp edx, [ecx+eax]		; ecx-> lpString2
	je @b
	jne @K1
@@3:
	mov esi, [esp+4]		; restore esi register
	xor eax, eax		; 2 strings are equal
	mov edi, [esp+8]		; restore edi register
	ret 8
@M1:
	movzx edi, byte ptr [ecx+eax]		; ecx-> lpString2
	movzx eax, dl
	mov esi, [esp+4]		; restore esi register
	sub eax, edi
	mov edi, [esp+8]		; restore edi register
	ret 8
@M2:
	movzx edi, byte ptr [ecx+eax+1]		; ecx-> lpString2
	movzx eax, dh
	mov esi, [esp+4]		; restore esi register
	sub eax, edi
	mov edi, [esp+8]		; restore edi register
	ret 8
@M3:
	movzx edi, byte ptr [ecx+eax+2]		; ecx-> lpString2
	movzx eax, dl
	mov esi, [esp+4]		; restore esi register
	sub eax, edi
	mov edi, [esp+8]		; restore edi register
	ret 8
@M4:
	movzx edi, byte ptr [ecx+eax+3]		; ecx-> lpString2
	movzx eax, dh
	mov esi, [esp+4]		; restore esi register
	sub eax, edi
	mov edi, [esp+8]		; restore edi register
	ret 8
	Lingo32 endp
Lingo32_E:
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16
Frank proc s1, s2			; granularity is 4 bytes; some extra code required to get bytes, not dwords
	mov ecx, [esp+4]
	mov eax, [esp+8]
;	xor ebx, ebx
;	mov ebx, 125
@@:
	mov edx, [ecx]		; Comparing two strings in edx and esi
	mov esi, [eax]
	xor edx, esi
	jnz @f
	add ecx, 4
	add eax, 4
	mov edx, [ecx]		; unrolled 1
	mov esi, [eax]
	xor edx, esi
	jnz @f
	add ecx, 4
	add eax, 4
	jmp @B
;	dec ebx
;	jnz @b
@@:	sub eax, [esp+8]	; return the relative position in eax
	ret 8
Frank endp
Frank_endp:

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Wait	0
OPT_Olly	2
OxPT_DebugA	/Zi	; activate symbols
OPT_Assembler	jwasm	; must be present in \bin
OxPT_DebugL	/debug /debugtype:cv	; for debugging
OxPT_Linker	linkv614	; must be present in \bin

[CPU]
Placement=0,0,392,515,3	; shows 3 xmm regs

[url=http://stackoverflow.com/questions/1128096/c-string-comparison-in-one-clock-cycle]@Paul:[/url]
The GLIBC strcmp() implementation is the naive one: read successive bytes until they differ.
Compiled with gcc-4 -O2, it uses the pcmpeqb and pmovmskb instructions.
I don't see how it could be any more efficient.  greyfade Jul 15 at 3:46

[url=http://www.strchr.com/strcmp_and_strlen_using_sse_4.2]SSE4:[/url]
SSE 4.2 introduces four instructions (PcmpEstrI, PcmpEstrM, PcmpIstrI, and PcmpIstrM) that can be used to
speed up text processing code (including strcmp, memcmp, strstr, and strspn functions)

	MovDqU xmm0, dqword[str1]
	PcmpIstrI xmm0, dqword[str2], imm

Equal each (imm[3:2] = 10). This operation compares two strings

	operand1 = "UseFlatAssembler"
	operand2 = "UsingAnAssembler"
	IntRes1  =  1100000111111111

For Instr_(:
Equal ordered (imm[3:2] = 11). Substring search (strstr). The first operand contains a string to search for,
the second is a string to search in. The bit mask includes 1 if the substring is found at the corresponding position:

	operand2 = "WhenWeWillBeWed!"
	operand1 = "We"
	IntRes1  =  000010000000100
